/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8d Professional
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :Inverted pendulum fuzzy controller 
Version : 
Date    : 1/8/2002
Author  : Mohammad                            
Company : Griffin                            
Comments: 


Chip type           : ATmega32
Program type        : Application
Clock frequency     : 16.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512
*****************************************************/

#include <mega32.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

////////////////////////////////////////////////////////////
//                      defines                           //
////////////////////////////////////////////////////////////

#define motor_dir_pin0 PORTC.0
#define motor_dir_pin1 PORTC.1

#define right 0
#define left 1

////////////////////////////////////////////////////////////
//                                                        //      
////////////////////////////////////////////////////////////

char rx_buffer1[8];
int teta=0,pr_teta=0,teta_dot=0;      
unsigned char dir=2;
char i,str[4];
int pwm;
int j=0;
////////////////////////////////////////////////////////////
//                    functions                            //
////////////////////////////////////////////////////////////

void motor_dir(unsigned char dir);
void micro_init(void);                                      
  

////////////////////////////////////////////////////////////
//             External Interrupt 0 service routine       //
////////////////////////////////////////////////////////////


interrupt [EXT_INT0] void ext_int0_isr(void)
{
        if(PIND.3==1)
        {
                teta++;
                dir=right;
                //motor_dir(right);
        }
        else
        {
                teta--;
                dir=left;
                //motor_dir(left);
        }
}

//////////////////////////////////////////////////////////// 
//            External Interrupt 1 service routine        //
////////////////////////////////////////////////////////////


interrupt [EXT_INT1] void ext_int1_isr(void)
{  
        if(PIND.2==0)
        {
                teta++;
                dir=right;
                //motor_dir(right);
        }
        else
        {
                teta--;
                dir=left; 
                //motor_dir(left);
        }
}              

//////////////////////////////////////////////////////////// 
//            External Interrupt 2 service routine        //
////////////////////////////////////////////////////////////


interrupt [EXT_INT2] void ext_int2_isr(void)
{
        teta=0;
} 

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;
                

////////////////////////////////////////////////////////////
//       USART Receiver interrupt service routine         //
////////////////////////////////////////////////////////////

interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
        if (data=='#')    
        {                  
                rx_buffer[0]=data;
                rx_wr_index=1;
        }
        else if (rx_wr_index==1 && data=='!') 
        { 
                
                
                teta_dot=(teta-pr_teta)*5;
                printf("%03d%03d%04d\r",teta,teta_dot,j);
        
                pr_teta=teta;
                j++;                     
                
                /////////////////////////
        }                    
        else if (rx_wr_index>=1 && rx_wr_index<=5) 
        { 
                rx_buffer[rx_wr_index]=data;
                rx_wr_index++;
                if (rx_wr_index==5)
                {
                           
                        strcpy(rx_buffer1,rx_buffer);
                        for (i=0;i<4;i++)
                        { 
                                str[i]=rx_buffer1[i+1];
                        } 
                        pwm=atoi(str);
                        
         
                        if(pwm > 0)
                                motor_dir(right); 
                        else if(pwm < 0)
                        motor_dir(left);
            
                        OCR2=abs(pwm);   
                }
        }else
                rx_wr_index=0;
         
        if (++rx_counter == RX_BUFFER_SIZE)
        {
                rx_counter=0;
                rx_buffer_overflow=1;
        };
   };
} 

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////


#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif
           

////////////////////////////////////////////////////////////
//       Timer 1 overflow interrupt service routine       //
////////////////////////////////////////////////////////////


interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{        /*
        if(teta > 0)
           motor_dir(right); 
        else if(teta < 0)
            motor_dir(left);
          */ 
               /* teta_dot=(teta-pr_teta)*5;
                printf("%03d%03d%04d\r",teta,teta_dot,j);
        
                pr_teta=teta;
                j++;
               */ 
        //TCNT1=15535;
        //TCNT1=40535;
}

////////////////////////////////////////////////////////////
//                       main                             //
////////////////////////////////////////////////////////////

void main(void)
{


micro_init();

printf("\r\n START \r");

while (1)
      {  
      /*
      if (ask2num==1) 
       {               
          for (i=0;i<=3;i++)
          { 
             str[i]=rx_buffer1[i+1];
          } 
          pwm=atoi(str);
         // OCR2=120; 
         
         if(pwm > 0)
           motor_dir(right); 
        else if(pwm < 0)
            motor_dir(left);
            
         OCR2=abs(pwm);
          ask2num=0;
       }  
       */
      };
}    

////////////////////////////////////////////////////////////
//                       motor_dir                        //
////////////////////////////////////////////////////////////

void motor_dir(unsigned char dir)
{
        if(dir==0)
        {      
                motor_dir_pin0=0;
                motor_dir_pin1=1;
                
        }
        else if(dir==1)
        {       
                motor_dir_pin0=1;
                motor_dir_pin1=0;
                
        }
}  
  
////////////////////////////////////////////////////////////
//                       micro_init                       //
////////////////////////////////////////////////////////////

void micro_init(void)
{
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func7=Out Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x80;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 250.000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x03;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 15.625 kHz
// Mode: Fast PWM top=FFh
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x6F;
TCNT2=0x00;
OCR2=0x00;    

/*// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: On
// INT1 Mode: Falling Edge
// INT2: Off
GICR|=0xC0;
MCUCR=0x0A;
MCUCSR=0x00;
GIFR=0xC0;
*/

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: On
// INT1 Mode: Falling Edge
// INT2: On
// INT2 Mode: Falling Edge
GICR|=0xE0;
MCUCR=0x0A;
MCUCSR=0x00;
GIFR=0xE0;


// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;
/*
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x67;
   */
 
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 38400
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// Global enable interrupts
#asm("sei")

}  

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////